/****************************
CrushFTP GUI Panel custom js
*****************************/
/* Do not change these lines */
var panelWebInterface = {};
panelWebInterface.localization = {};
/****************************/

// Panel details
var panelName = "WebInterface";
var _panel = $("#pnl" + panelName);

// Localizations
panelWebInterface.localization = {
	headerText : " ",
	lblCustomFormsTabText : "Custom Forms",
	lblMiniURLsTabText : "Mini URLs",
	lblOptionsTabText : "Options",
	lblTextTabText : "Text",
	lblProxyTabText : "Proxy",
	btnCreateNewFormText : "New",
	btnCreateDuplicateOfFormText : "Duplicate",
	btnDeleteFormText : "Delete",
	lblFormBuilderLabelText : " Label ",
	lblFormBuilderTextFieldInputText : "Text Field",
	lblFormBuilderBigTextFieldText : "Big Text Field (Textarea)",
	lblFormBuilderDropdownText : "Dropdown",
	lblFormBuilderCheckboxText : " Checkbox ",
	lblFormBuilderRadioText : " Radio ",
	btnFormBuilderEditEntryText : " Edit Entry",
	btnFormBuilderMoveEntryUpText : " Move Entry Up ",
	btnFormBuilderMoveEntryDownText : " Move Entry Down ",
	btnFormBuilderDeleteEntryText : " Delete Entry ",
	lblFormBuilderPreviewText : " Preview: ",
	pnlMiniUrlsHeaderNoteText : " A mini URL is a secure URL you can send to clients. It allows an end user to accsss a specific file, or folder without needing to login. It does not include the username or password as part of the URL. When a user uses the URL, it allows them to be logged in to an account, to retrieve the file specified. You may also set an expiration of when tns URL will automatically be deleted and no longer valid. ",
	btnMiniUrlsAddMiniURLText : "Add Mini URL",
	btnMiniUrlsRemoveURLText : "Remove Mini URL",
	lblMiniUrlsFormURLKeyText : "MiniURL Key:",
	btnMiniUrlsFormCopyToClipboardText : "Copy To Clipboard",
	lblMiniUrlsFormURLPointsToText : "MiniURL Points To:",
	lblMiniUrlsExpirationDateText : "Expiration Date:",
	lblMiniUrlsFormSetDaysText : "Set Days",
	lblMiniUrlsFormSetDaysDescText : "Example 01/01/2008 08:00 AM",
	lblMiniUrlsLoginUsernameText : "Login Username:",
	lblMiniUrlsLoginPasswordText : "Login Password:",
	pnlOptionsHeaderNoteText : " You may set a detault logo file to be used. Thile file will be used as the detault unless you override it with a custom setting on a per user basis. This includes the logo that is displayed for the login page. <br> <br> Its important to set this here as just replacing the logo.gif file will get overwritten the next time you update. Your logo file must be in the Weblnterface/images/ directory for it to work. Enter the name of your logo file below. The default is 'logo.gif', but you should use a different name to prevent your logo from being overwritten ",
	pnlOptionsHeaderNotePart2Text : ' Multiple domains pointed at this one machine? Make specific login pages styled to fit each domain so your customers get the styled page you want them to see. You may also use this to alter the default login page users will see. Dont use the default "login.html" as its a file CrushFTP owns and will update it with each new release. So make your own file and point the login at it. ',
	btnOptionsAddNewLoginPageText : " Add New Login Page",
	btnOptionsEditLoginPageText : " Edit Selected Login Page ",
	btnOptionsDeleteLoginPageText : " Remove Selected Login Page ",
	btnOptionsLoginPageMoveUpText : " Move Up ",
	btnOptionsLoginPageMoveDownText : " Move Down ",
	lblBoxAllowGZipText : "Allow GZIP Encoding",
	lblBoxDisplayAlternateLogoText : "Display alternate '.logo.png' in folders",
	lblHideEmailForgottehPaswdLinkText : "Hide email forgotten password link",
	lblDefaultWindowTitleText : "Default window Title",
	lblOptionsHeaderNoteText : " Enter a footer message that will be added to all user's pages. This is a global footer, and is different than the footer text that can be applied on a per user basis. ",
	lblOptions404ErrorHeaderText : " 404 Error Response Text: ",
	lblOptions404ErrorDescText : " In rare cases a 404 error may be returned, and this text will be included. ",
	lblOptionsPasswordReminderHeaderText : " Password Reminder Email (If they click the 'I forgot my password, email it to me'. link) ",
	lblOptionsPasswordReminderMailSubjectLabelText : "Subject:",
	lblOptionsPasswordReminderMailBodyLabelText : "Body:",
	lblProxyOptionsKeepCopyOfUploadedFilesText : "Keep copy of uploaded files passing through server.",
	lblProxyOptionsUploadedFileRepoText : "Uploaded file repository:",
	lblProxyOptionsKeepCopyOfDownloadedFilesText : "Keep copy of downloaded files passing through server.",
	lblProxyOptionsDownloadedFileRepoText : "Downloaded file repository:",
	btnBrowseText : 'Browse',
	lblProxyHostRulesHeaderText : " Proxy Host Rules ",
	btnProxyAddNewRuleText : " Add New",
	btnProxyEditRuleText : " Edit Selected ",
	btnProxyRemoveRuleText : " Remove Selected ",
	btnProxyRuleMoveUpText : " Move Up ",
	btnProxyRuleMoveDownText : " Move Down ",
	btnResetText : "Reset All Prefs to Default",
	btnCancelText : "Cancel",
	btnOKText : "Ok"
};

// Assign localizations
localizations.panels[panelName] = $.extend(panelWebInterface.localization, localizations.panels[panelName]);

panelWebInterface.formControls = {};

// Interface methods
panelWebInterface.init = function(){
	applyLocalizations(panelName, localizations.panels);
	setPageTitle(panelWebInterface.localization.Header, true);
	panelWebInterface.bindData();
	panelWebInterface.bindEvents();
}

panelWebInterface.bindData = function()
{
	var prefs = $(document).data("GUIXMLPrefs");
	bindValuesFromXML(_panel, prefs);
	var loginPageList = common.data.getSubValueFromPrefs("login_page_list");
	if(loginPageList)
	{
		var formloginPageList = $("#loginPageList", _panel);
		for(var i=0;i<loginPageList.length;i++)
		{
			var curItem = loginPageList[i];
			if(curItem)
			{
				var favicon = common.data.getTextContentFromPrefs(curItem, "favicon");
				var page = common.data.getTextContentFromPrefs(curItem, "page");
				var domain = common.data.getTextContentFromPrefs(curItem, "domain");
				var loginPage = domain + " -> " + page + ":" + favicon;
				var newControl = $("<li class='ui-widget-content' loginPage='"+loginPage+"'>"+loginPage+"</li>");
				formloginPageList.append(newControl);
				newControl.data("controlData", curItem);
			}
		}
	}

	var proxyRules = common.data.getSubValueFromPrefs("proxyRules");
	if(proxyRules)
	{
		var formProxyRulesList = $("#proxyRules", _panel);
		for(var i=0;i<proxyRules.length;i++)
		{
			var curItem = proxyRules[i];
			if(curItem)
			{
				var proxyName = common.data.getTextContentFromPrefs(curItem, "proxyName");
				if(proxyName.length>0)
				{
					var protocol = common.data.getTextContentFromPrefs(curItem, "protocol");
					var host = common.data.getTextContentFromPrefs(curItem, "host");
					var condition = common.data.getTextContentFromPrefs(curItem, "condition");
					var criteria1 = common.data.getTextContentFromPrefs(curItem, "criteria1");
					var criteria2 = common.data.getTextContentFromPrefs(curItem, "criteria2");
					var port = common.data.getTextContentFromPrefs(curItem, "port");
					var proxyRuleText = proxyName + "   " + protocol + "://" + host + ":" + port + "   " ;
					var ruleType = "Custom";
					if(condition == "=" && criteria1 == "%user_name%" && criteria2 == "*")
					{
						ruleType = "WhiteList";
					}
					else if(condition == "=" && criteria1 == "1" && criteria2 == "2")
					{
						ruleType = "BlackList";
					}
					if(ruleType == "Custom")
					{
						proxyRuleText = proxyRuleText + criteria1 + " " + condition + " " + criteria2;
					}
					else
					{
						proxyRuleText = proxyRuleText + ruleType;
					}
					var newControl = $("<li class='ui-widget-content'>"+proxyRuleText+"</li>");
					formProxyRulesList.append(newControl);
					newControl.data("controlData", curItem);
				}
			}
		}
	}

	var CustomForms = common.data.getSubValueFromPrefs("CustomForms");
	if(CustomForms)
	{
		var formCustomFormList = $("#CustomForms", _panel);
		for(var i=0;i<CustomForms.length;i++)
		{
			var curItem = CustomForms[i];
			if(curItem)
			{
				var name = common.data.getTextContentFromPrefs(curItem, "name");
				var id = common.data.getTextContentFromPrefs(curItem, "id");
				formCustomFormList.append("<option value='"+id+"'>"+name+"</option>");
				panelWebInterface.formControls[id] = curItem;
			}
		}
	}

	var miniURLs = common.data.getSubValueFromPrefs("miniURLs");
	if(miniURLs)
	{
		var formMiniURLsList = $("#miniURLs", _panel);
		for(var i=0;i<miniURLs.length;i++)
		{
			var curItem = miniURLs[i];
			if(curItem)
			{
				var key = common.data.getTextContentFromPrefs(curItem, "key");
				var redirect= common.data.getTextContentFromPrefs(curItem, "redirect");
				var newControl = $("<li class='ui-widget-content' key='" + key + "'>" + key + " --> " +  redirect + "</li>");
				formMiniURLsList.append(newControl);
				newControl.data("controlData", curItem);
			}
		}
	}
	panelWebInterface.bindFormDetails();
}

panelWebInterface.bindEvents = function()
{
	/* CustomForms Tab events*/
	var formloginPageList = $("#loginPageList", _panel);
	formloginPageList.selectable({
		selected: function(event, ui) {
			var selected = $(ui.selected);
			selected.parent().find(".ui-widget-header").removeClass("ui-widget-header");
			selected.addClass("ui-widget-header");
			return false;
		}
	});

	var proxyRules = $("#proxyRules", _panel);
	proxyRules.selectable({
		selected: function(event, ui) {
			var selected = $(ui.selected);
			selected.parent().find(".ui-widget-header").removeClass("ui-widget-header");
			selected.addClass("ui-widget-header");
			return false;
		}
	});

	var itemControls = $("#custom_form_controls", _panel);
	itemControls.selectable({
		selected: function(event, ui) {
			var selected = $(ui.selected);
			selected.parent().find(".ui-widget-header").removeClass("ui-widget-header");
			selected.addClass("ui-widget-header");
			return false;
		}
	});

	var formCustomFormList = $("#CustomForms", _panel);
	formCustomFormList.change(function(){
		panelWebInterface.bindFormDetails();
	});

	$("a#moveControlUp, a#moveControlDown", _panel).click(function(){
		if(itemControls.find("li.ui-selected").length>0)
		{
			panelWebInterface.moveFormControl(itemControls.find("li.ui-selected"), $(this).is("#moveControlUp"));
			itemsChanged(true);
		}
		return false;
	});

	$("a#deleteFormControl", _panel).click(function(){
		if(itemControls.find("li.ui-selected").length>0)
		{
			jConfirm("Are you sure you wish to remove this item?","Confirm", function(flag){
				if(flag)
				{
					var toFocus = [];
					var selected = itemControls.find("li.ui-selected");
					var name = selected.attr("rel");
					if(name)
					{
						var preview = $("table","#formPreview");
						if(preview.find("tr#" + name).length>0)
						{
							preview.find("tr#" + name).remove();
						}
					}
					if(selected.next("li").length>0)
					{
						toFocus = selected.next("li");
					}
					else if(selected.prev("li").length>0)
					{
						toFocus = selected.prev("li");
					}
					toFocus.addClass("ui-widget-header").addClass("ui-selected");
					var controlData = selected.data("controlData");
					var formCustomFormList = $("#CustomForms", _panel);
					var formId = formCustomFormList.val();
					var controls = [];
					var form = panelWebInterface.formControls[formId];
					if(form && form.entries && form.entries.length>0 && form.entries[0].entries_subitem)
					{
						controls = panelWebInterface.formControls[formId].entries[0].entries_subitem;
						var index = controls.indexOf(controlData);
						controls.splice (index, 1);
						panelWebInterface.formControls[formId].entries[0].entries_subitem = controls;
						panelWebInterface.bindFormDetails(formId, controlData);
						itemsChanged(true);
					}
				}
			}
			,{
				okButtonText : "Yes",
				cancelButtonText : "No"
			});
		}
		return false;
	});

	$("a#editFormControl", _panel).click(function(){
		if(itemControls.find("li.ui-selected").length>0)
		{
			var selected = itemControls.find("li.ui-selected");
			var controlData = selected.data("controlData");
			if(controlData)
			{
				var itemType = getTextValueFromXMLNode(controlData.item_type, "");
				if(!itemType)
					itemType = getTextValueFromXMLNode(controlData.type, "");
				if(itemType == "text")
				{
					$("#addNewTextbox", _panel).trigger("click", [controlData]);
				}
				else if(itemType == "textarea")
				{
					$("#addNewTextarea", _panel).trigger("click", [controlData]);
				}
				else if(itemType == "combo")
				{
					$("#addNewDropdown", _panel).trigger("click", [controlData]);
				}
				else if(itemType == "checkbox")
				{
					$("#addNewCheckbox", _panel).trigger("click", [controlData]);
				}
				else if(itemType == "radio")
				{
					$("#addNewRadio", _panel).trigger("click", [controlData]);
				}
				else if(itemType == "label")
				{
					$("#addNewLabel", _panel).trigger("click", [controlData]);
				}
			}
		}
		return false;
	});

	$("a#createNewForm, a#duplicateForm", _panel).click(function(){
		var formName =  "";
		var duplicate = false;
		var formId = false;
		if($(this).is("a#duplicateForm"))
		{
			duplicate = true;
			formId = $("select#CustomForms").find("option:selected").text();
			formName = formId + "_copy";
		}
		jPrompt("Please enter a name for this form:", formName, "Custom Form Name", function(value){
			formName = value;
			if(formName)
			{
				if($("select#CustomForms").find("option[value='"+formName+"']").length==0)
				{
					$("select#CustomForms").append("<option value='"+formName+"'>"+formName+"</option>");
					$("select#CustomForms").find("option[value='"+formName+"']").attr("selected", "selected");
					var entries = [{entries_subitem:[]}];
					if(duplicate && panelWebInterface.formControls && panelWebInterface.formControls[formId] && panelWebInterface.formControls[formId].entries)
					{
						var controlData = $.extend(true, {}, panelWebInterface.formControls[formId]);
						entries = controlData.entries;
					}
					panelWebInterface.formControls[formName] = {
						entries:entries,
						name:[{text:formName}],
						id:[{text:formName}]
					};
					panelWebInterface.bindFormDetails(formName);
					itemsChanged(true);
				}
				else
				{
					growl("Form exist", "Please select different name as form exist with the name specified : " + formName, true, 3000);
					$("a#createNewForm").trigger("click");
				}
			}
		});
		return false;
	});

	$("a#deleteForm", _panel).click(function(){
		if($("select#CustomForms").val().length>0)
		{
			jConfirm("Are you sure you wish to remove this item?","Confirm", function(flag){
				var toFocus = [];
				var selected =  $("select#CustomForms").find("option:selected");
				if(selected.next("option").length>0)
				{
					toFocus = selected.next("option");
				}
				else if(selected.prev("option").length>0)
				{
					toFocus = selected.prev("option");
				}
				selected.remove();
				var controls = panelWebInterface.formControls;
				var newControls = {};
				for(var item in controls)
				{
					if(item != selected.val())
					{
						newControls[item] = controls[item];
					}
				}
				panelWebInterface.formControls = newControls;
				panelWebInterface.bindFormDetails();
			},{
				okButtonText : "Yes",
				cancelButtonText : "No"
			});
		}
		return false;
	});

	$("#addNewLabel", _panel).click(function(evt, control){
		var labelName =  "";
		var labelValue = "";
		if(control)
		{
			labelName = getTextValueFromXMLNode(control.label, "");
			labelValue = getTextValueFromXMLNode(control.value, "");
		}
		jPrompt("Enter left text label for this entry:", labelName, "Label", function(value){
			labelName = value;
			if(labelName!=null)
			{
				jPrompt("Enter right text label for this entry:", labelValue, "Label", function(value){
					labelValue = value;
					if(control)
					{
						panelWebInterface.updateFormControl(control, {
							item_type:[{text:"label"}],
							label:[{text:labelName}],
							name:[{text:labelName}],
							value:[{text:labelValue}],
							options:{},
							required:[{text:false}],
							type:[{text:"label"}]
						});
					}
					else
					{
						panelWebInterface.addControlToTheList("label", labelName, "", labelValue, [], false, "", "label");
					}
					itemsChanged(true);
				});
			}
		});
		return false;
	});

	$("#addNewTextbox", _panel).click(function(evt, control){
		var labelName =  "";
		if(control)
		{
			labelName = getTextValueFromXMLNode(control.label, "");
		}
		jPrompt("Enter text label for this entry:", labelName, "Label", function(value){
			labelName = value;
			if(labelName!=null)
			{
				var fieldName = "";
				if(control)
				{
					fieldName = getTextValueFromXMLNode(control.name, "");
				}
				function nameEntry()
				{
					jPrompt("Enter name for this entry (no spaces, or special characters):", fieldName, "Name", function(value){
						fieldName = value;
						if(fieldName)
						{
							if(startsWithNumber(fieldName))
							{
								jAlert("Name can not start with number", "Message", function(){
								nameEntry();
								});
							}
							else
							{
								var size = 15;
								if(control)
								{
									size = getTextValueFromXMLNode(control.size, "");
								}
								function sizeEntry()
								{
									jPrompt("Enter size for this entry in characters:", size, "Size", function(value){
										size = value;
										if(size!=null)
										{
											var fieldValue = "";
											if(control)
											{
												fieldValue = getTextValueFromXMLNode(control.value, "");
											}
											jPrompt("Enter starting value for this entry:", fieldValue, "Value", function(value){
												fieldValue = value;
												var required = true;
												jConfirm("Is this entry required?", "Required", function(_required){
													required = _required;
													if(control)
													{
														panelWebInterface.updateFormControl(control, {
															item_type:[{text:"text"}],
															label:[{text:labelName}],
															name:[{text:fieldName}],
															value:[{text:fieldValue}],
															options:{},
															required:[{text:required.toString()}],
															size:[{text:size}],
															type:[{text:"text"}],
															cols:[],
															rows:[]
														});
													}
													else
													{
														panelWebInterface.addControlToTheList("text", labelName, fieldName, fieldValue, "", required, size, "text");
													}
													itemsChanged(true);
												},{
													okButtonText : "Yes",
													cancelButtonText : "No"
												});
											});
										}
									});
								}
								sizeEntry();
							}
						}
						else if(fieldName != null)
						{
							nameEntry();
						}
					});
				}
				nameEntry();
			}
		});
		return false;
	});

	$("#addNewTextarea", _panel).click(function(evt, control){
		var labelName =  "";
		if(control)
		{
			labelName = getTextValueFromXMLNode(control.label, "");
		}
		jPrompt("Enter text label for this entry:", labelName, "Label", function(value){
			labelName = value;
			if(labelName != null)
			{
				var fieldName = "";
				if(control)
				{
					fieldName = getTextValueFromXMLNode(control.name, "");
				}
				function nameEntry()
				{
					jPrompt("Enter name for this entry (no spaces, or special characters):", fieldName, "Name", function(value){
						fieldName = value;
						if(fieldName)
						{
							if(startsWithNumber(fieldName))
							{
								jAlert("Name can not start with number, can not be empty or contain : <br />" + window.notAllowedChars, "Message", function(){
								nameEntry();
								});
							}
							else
							{
								var cols = 30;
								if(control)
								{
									cols = getTextValueFromXMLNode(control.cols, "");
								}
								function sizeEntry()
								{
									jPrompt("Enter width for this entry in characters:", cols, "Cols", function(value){
										cols = value;
										if(cols)
										{
											var rows = 5;
											if(control)
											{
												rows = getTextValueFromXMLNode(control.rows, "");
											}
											jPrompt("Enter number of text rows for this entry:", rows, "Rows", function(value){
												rows = value;
												if(rows)
												{
													var fieldValue = "";
													if(control)
													{
														fieldValue = getTextValueFromXMLNode(control.value, "");
													}
													jPrompt("Enter starting value for this entry:", fieldValue, "Value", function(value){
														fieldValue = value;
														var required = true;
														jConfirm("Is this entry required?", "Required", function(value){
															required = value;
															if(control)
															{
																panelWebInterface.updateFormControl(control, {
																	item_type:[{text:"textarea"}],
																	label:[{text:labelName}],
																	name:[{text:fieldName}],
																	value:[{text:fieldValue}],
																	options:{},
																	required:[{text:required.toString()}],
																	size:[],
																	type:[{text:"textarea"}],
																	cols:[{text:cols}],
																	rows:[{text:rows}]
																});
															}
															else
															{
																panelWebInterface.addControlToTheList("textarea", labelName, fieldName, fieldValue,  "", required, "", "textarea", cols, rows);
															}
															itemsChanged(true);
														},{
															okButtonText : "Yes",
															cancelButtonText : "No"
														});
													});
												}
											});
										}
									});
								}
								sizeEntry();
							}
						}
						else if(fieldName != null)
						{
							nameEntry();
						}
					});
				}
				nameEntry();
			}
		});
		return false;
	});

	$("#addNewDropdown,#addNewCheckbox,#addNewRadio", _panel).click(function(evt, control){
		var labelName =  "";
		if(control)
		{
			labelName = getTextValueFromXMLNode(control.label, "");
		}
		var items = 3;
		var itemTypeText = "items in this list";
		var itemType = "combo";
		if($(this).is("#addNewCheckbox"))
		{
			items = 2;
			itemTypeText = "checkboxes";
			itemType = "checkbox";
		}
		else if($(this).is("#addNewRadio"))
		{
			items = 2;
			itemTypeText = "radion options";
			itemType = "radio";
		}
		var origOptions = [];
		if(control)
		{
			var options = control.options;
			options = options[0]["options_subitem"];
			items = options.length;
			for(var i=0;i<options.length;i++)
			{
				var curItem = options[i];
				if(curItem)
				{
					var opt = curItem.text;
					origOptions.push(opt);
				}
			}
		}
		function controlEntry()
		{
			jPrompt("Enter text label for this entry:", labelName, "Label", function(value){
				labelName = value;
				if(labelName != null)
				{
					var fieldName = "";
					if(control)
					{
						fieldName = getTextValueFromXMLNode(control.name, "");
					}
					function nameEntry()
					{
						jPrompt("Enter name for this entry (no spaces, or special characters):", fieldName, "Name", function(value){
							fieldName = value;
							if(fieldName)
							{
								if(startsWithNumber(fieldName) || fieldName.length == 0)
								{
									jAlert("Name can not start with number, can not be empty or contain : <br />" + window.notAllowedChars, "Message", function(){
									nameEntry();
									});
								}
								else
								{
									function itemsEntry()
									{
										jPrompt("How many " + itemTypeText + " :", items, "Items", function(value){
												items = value;
												if(items && isNumeric(items))
												{
													var count = 1;
													var options = [];
													function optionEntry()
													{
														var curVal = "";
														if(origOptions.length >= items-1 && origOptions[count - 1])
														{
															curVal = common.methods.decode(origOptions[count - 1]);
														}
														jPrompt("Enter item " + count + " : ", curVal, "Item " + count, function(value){
															if(value != null)
															{
																options.push({text:common.methods.htmlEncode(value)});
																count++;
																if(count<=items)
																{
																	optionEntry();
																}
																else
																{
																	var required = true;
																	jConfirm("Is this entry required?", "Required", function(value){
																		required = value;
																		if(control)
																		{
																			panelWebInterface.updateFormControl(control, {
																				item_type:[{text:itemType}],
																				label:[{text:labelName}],
																				name:[{text:fieldName}],
																				value:[],
																				options:[{options_subitem:options}],
																				required:[{text:required.toString()}],
																				size:[],
																				type:[{text:itemType}],
																				cols:[],
																				rows:[]
																			});
																		}
																		else
																		{
																			panelWebInterface.addControlToTheList(itemType, labelName, fieldName, "",  [{options_subitem:options}], required, "", itemType);
																		}
																		itemsChanged(true);
																	},{
																		okButtonText : "Yes",
																		cancelButtonText : "No"
																	});
																}
															}
														});
													}
													optionEntry();
												}
												else
												{
													itemsEntry();
												}
										});
									}
									itemsEntry();
								}
							}
						});
					}
					nameEntry();
				}
				else if(labelName != null)
				{
					controlEntry();
				}
			});
		}
		controlEntry();
		return false;
	});

	/* MiniURLs tab events*/
	var miniURLs = $("#miniURLs", _panel);
	miniURLs.selectable({
		selected: function(event, ui) {
			var selected = $(ui.selected);
			selected.parent().find(".ui-widget-header").removeClass("ui-widget-header");
			selected.addClass("ui-widget-header");
			panelWebInterface.bindMiniURLDetails(selected);
			return false;
		}
	});

	var miniURLDetails  = $("#miniURLDetails", _panel);
	miniURLDetails.find("input").bind("textchange", function(){
		var item = miniURLs.find("li.ui-selected");
		if(!item || item.length==0)return;
		var data = item.data("controlData");
		if(data)
		{
			data[$(this).attr("id")] = [{text:$(this).val()}];
		}
		item.data("controlData", data);
	});

	$("a#addMiniURL", _panel).click(function(){
		var key = generateRandomCode(13, true);
		var redirect = "/path/file.ext";
		var newControl = $("<li class='ui-widget-content' key='" + key + "'>" + key + " --> " +  redirect + "</li>");
		common.UI.addItem($("#miniURLs", _panel)
			, $("<li class='ui-widget-content' key='" + key + "'>" + key + " --> " +  redirect + "</li>")
			, {
				pass:[{text:""}],
				key:[{text:key}],
				user:[{text:""}],
				redirect:[{text:redirect}],
				expire:[{text:""}]
			}
			, panelWebInterface.bindMiniURLDetails);
		itemsChanged(true);
		return false;
	});

	$("a#removeMiniURL", _panel).click(function(){
		common.UI.removeItem($("#miniURLs", _panel), panelWebInterface.bindMiniURLDetails);
		itemsChanged(true);
		return false;
	});

	/* Options tab events */
	$("a#addNewLoginPage", _panel).click(function(evt, controlData, control){
		var domainName =  "";
		if(controlData)
		{
			domainName = getTextValueFromXMLNode(controlData.domain, "");
		}
		jPrompt("Please enter the domain. (Pattern matching is allowed such as *.domain.com)", domainName, "Input", function(value){
				domainName = value;
				if(domainName != null)
				{
					if(domainName.length == 0)
					{
						$("#addNewLoginPage", _panel).trigger("click");
						return;
					}
					var fileName = "";
					if(controlData)
					{
						fileName = getTextValueFromXMLNode(controlData.page, "");
					}
					function nameEntry()
					{
						jPrompt("Please enter the filename. (The file must be in the WebInterface folder) :", fileName, "Input", function(value){
							fileName = value;
							if(fileName != null)
							{
								var favicon = "";
								if(controlData)
								{
									favicon = getTextValueFromXMLNode(controlData.favicon, "");
								}
								function faviconEntry()
								{
									jPrompt("Please enter the filename for your favicon.ico file. (The file must be in the WebInterface folder)", favicon, "Input", function(value){
										favicon = value;
										if(favicon != null)
										{
											var formloginPageList = $("#loginPageList", _panel);
											var loginPage = domainName + " -> " + fileName + ":" + favicon;
											var newControl = $("<li class='ui-widget-content'>"+loginPage+"</li>");
											newControl.data("controlData", {
												favicon:[{text:favicon}],
												page:[{text:fileName}],
												domain:[{text:domainName}]
											});
											if(control)
											{
												control.replaceWith(newControl);
											}
											else
											{
												formloginPageList.append(newControl);
											}
											if(newControl)
											{
												newControl.parent().find(".ui-widget-header").removeClass("ui-widget-header").removeClass("ui-selected");
												newControl.addClass("ui-widget-header").addClass("ui-selected");
											}
											itemsChanged(true);
										}
									});
								}
							faviconEntry();
						}
					});
				}
				nameEntry();
			}
		});
		return false;
	});

	$("a#editNewLoginPage", _panel).click(function(evt, control){
		var formloginPageList = $("#loginPageList", _panel);
		var selected = formloginPageList.find("li.ui-selected");
		if(selected && selected.length > 0)
		{
			$("#addNewLoginPage", _panel).trigger("click", [selected.data("controlData"), selected]);
		}
		return false;
	});

	$("a#removeLoginPage", _panel).click(function(evt, control){
		common.UI.removeItem($("#loginPageList", _panel));
		itemsChanged(true);
		return false;
	});

	$("a#moveLoginPageUp, a#moveLoginPageDown", _panel).click(function(evt, control){
		var formloginPageList = $("#loginPageList", _panel);
		var selected = formloginPageList.find("li.ui-selected");
		if(selected && selected.length > 0)
		{
			if($(this).is("#moveLoginPageUp") && selected.prev("li").length>0)
			{
				selected.prev("li").before(selected);
			}
			else if($(this).is("#moveLoginPageDown") && selected.next("li").length>0)
			{
				selected.next("li").after(selected);
			}
			itemsChanged(true);
		}
		return false;
	});

	/* Proxy Tab Events */
	$("a#addNewProxyRule", _panel).click(function(evt, controlData, control){
		var ruleName =  "";
		if(controlData)
		{
			ruleName = getTextValueFromXMLNode(controlData.proxyName, "");
		}
		jPrompt("Please enter a name for this item : ", ruleName, "Name", function(value){
			ruleName = value;
			if(ruleName != null)
			{
				if(ruleName.length == 0)
				{
					$("#addNewProxyRule", _panel).trigger("click");
					return;
				}
				var hostName = "";
				if(controlData)
				{
					hostName = getTextValueFromXMLNode(controlData.host, "");
				}
				function hostNameEntry()
				{
					jPrompt("Enter a host name or IP (wildcards accepted) : ", hostName, "Input", function(value){
						hostName = value;
						if(hostName)
						{
							var protocol = "FTP";
							if(controlData)
							{
								protocol = getTextValueFromXMLNode(controlData.protocol, "");
							}
							function protocolEntry()
							{
								jPrompt("Choose the protocol for the host : ", protocol, "Protocol", function(value){
									protocol = value;
									if(protocol)
									{
										var port = "21";
										if(controlData)
										{
											port = getTextValueFromXMLNode(controlData.port, "");
										}
										function portEntry()
										{
											jPrompt("Enter a port : ", port, "Port", function(value){
												port = value;
												if(port)
												{
													var rule = "";
													var condition = "=";
													var criteria1 = "";
													var criteria2 = "";
													if(controlData)
													{
														rule = getTextValueFromXMLNode(controlData.condition, "");
														criteria1 = getTextValueFromXMLNode(controlData.criteria1, "");
														criteria2 = getTextValueFromXMLNode(controlData.criteria2, "");
													}
													function buildControl()
													{
														var formProxyRulesList = $("#proxyRules", _panel);
														var proxyRule = ruleName + "   " + protocol + "://" + hostName + ":" + port + "   ";
														if(rule == "Custom")
														{
															proxyRule = proxyRule + criteria1 + " " + condition + " " + criteria2;
														}
														else
														{
															proxyRule = proxyRule + rule;
														}
														var newControl = $("<li class='ui-widget-content'>"+proxyRule+"</li>");
														newControl.data("controlData", {
															port:[{text:port}],
															host:[{text:hostName}],
															protocol:[{text:protocol}],
															proxyName:[{text:ruleName}],
															condition:[{text:condition}],
															criteria1:[{text:criteria1}],
															criteria2:[{text:criteria2}]
														});
														if(control)
														{
															control.replaceWith(newControl);
														}
														else
														{
															formProxyRulesList.append(newControl);
														}
														if(newControl)
														{
															newControl.parent().find(".ui-widget-header").removeClass("ui-widget-header").removeClass("ui-selected");
															newControl.addClass("ui-widget-header").addClass("ui-selected");
														}
														itemsChanged(true);
													}
													function ruleEntry()
													{
														jPrompt("Choose the type of rule for the host : ", rule, "Proxy Rule", function(value){
															rule = value;
															if(rule != "Custom")
															{
																if(rule == "WhiteList")
																{
																	condition = "=";
																	criteria1 = "%user_name%";
																	criteria2 = "*";
																}
																else if(rule == "BlackList")
																{
																	condition = "=";
																	criteria1 = "1";
																	criteria2 = "2";
																}
																buildControl();
															}
															else if(rule == "Custom")
															{
																if(criteria1 == "")
																{
																	criteria1 = "%user_name%"
																}
																function criteriaEntry1()
																{
																	jPrompt("Enter criteria 1 : ", criteria1, "Criteria 1", function(value){
																		criteria1 = value;
																		if(criteria1)
																		{
																			function conditionEntry()
																			{
																				jPrompt("Choose the condition : ", condition, "Condition", function(value){
																					condition = value;
																					if(condition)
																					{
																						function criteriaEntry2()
																						{
																							jPrompt("Enter criteria 2 : ", criteria2, "Criteria 2", function(value){
																								criteria2 = value;
																								if(criteria2)
																								{
																									buildControl();
																								}
																							});
																						}
																						criteriaEntry2();
																					}
																				}, ["=", "!="]);
																			}
																			conditionEntry();
																		}
																	});
																}
																criteriaEntry1();
															}
														}, ["Whitelist","Blacklist","Custom"]);
													}
													ruleEntry();
												}
											});
										}
										portEntry();
									}
								}, ["FTP", "FTPS", "SFTP"]);
							}
							protocolEntry();
						}
					});
				}
				hostNameEntry();
			}
		});
		return false;
	});

	$("a#editProxyRule", _panel).click(function(evt, control){
		var formProxyRulesList = $("#proxyRules", _panel);
		var selected = formProxyRulesList.find("li.ui-selected");
		if(selected && selected.length > 0)
		{
			$("#addNewProxyRule", _panel).trigger("click", [selected.data("controlData"), selected]);
		}
		return false;
	});

	$("a#removeProxyRule", _panel).click(function(evt, control){
		common.UI.removeItem($("#proxyRules", _panel));
		itemsChanged(true);
		return false;
	});

	$("a#moveProxyRuleUp, a#moveProxyRuleDown", _panel).click(function(evt, control){
		var formProxyRulesList = $("#proxyRules", _panel);
		var selected = formProxyRulesList.find("li.ui-selected");
		if(selected && selected.length > 0)
		{
			if($(this).is("#moveProxyRuleUp") && selected.prev("li").length>0)
			{
				selected.prev("li").before(selected);
			}
			else if($(this).is("#moveProxyRuleDown") && selected.next("li").length>0)
			{
				selected.next("li").after(selected);
			}
			itemsChanged(true);
		}
		return false;
	});

	$("a.serverFilePickButton", _panel).each(function(){
		$(this).click(function(){
			var curElem = $(this);
			curElem.crushFtpVFSBrowserPopup({
				type : curElem.attr("PickType") || 'dir',
				callback : function(selectedPath){
					$("#" + curElem.attr("rel"), _panel).val(selectedPath).trigger("change");
				}
			});
			return false;
		});
	});

	$("a#copyToClipboardMiniURLKey", _panel).click(function(){
		var miniURLs = $("#miniURLs", _panel);
		var item = miniURLs.find("li.ui-selected");
		if(!item || item.length==0)return false;
		var url = $("input#miniURLHost", _panel).val() + $("input#key", _panel).val();
		jPrompt("URL", url, "Copy", false, false, false, {hideCancelButton:true});
		return false;
	});

	$("a#quickSet", _panel).click(function(){
		var input = $("#expire", _panel);
		var selDate = input.datepicker("getDate");
		var myDate = new Date();
		var defaultDays = 1.5;
		if(selDate)
		{
			var t2 = selDate.getTime();
			var t1 = myDate.getTime();
			defaultDays = parseInt((t2-t1)/(24*3600*1000)) + 1;
		}
		jPrompt("Enter the number of days from now until this account expires : ", defaultDays, "Input", function(value){
			var days = parseInt(value);
			if(days != null && days != NaN)
			{
				if (days == NaN) days = 0;
				if (days > 0) {
					myDate.setDate(myDate.getDate() + days);
					input.datepicker( "setDate" , myDate );
				}
			}
		});
		$("#ui-datepicker-div").hide();
		return false;
	});
}

panelWebInterface.updateFormControl = function(controlData, newData)
{
	var formCustomFormList = $("#CustomForms", _panel);
	var formId = formCustomFormList.val();
	var controls = [];
	var form = panelWebInterface.formControls[formId];
	if(form && form.entries && form.entries.length>0 && form.entries[0].entries_subitem)
	{
		controls = panelWebInterface.formControls[formId].entries[0].entries_subitem;
		var index = controls.indexOf(controlData);
		if(index>=0)
		{
			controls[index] = newData;
			panelWebInterface.formControls[formId].entries[0].entries_subitem = controls;
			panelWebInterface.bindFormDetails(formId, controlData);
		}
	}
}

panelWebInterface.moveFormControl = function(control, up)
{
	var controlData = control.data("controlData");
	var formCustomFormList = $("#CustomForms", _panel);
	var formId = formCustomFormList.val();
	var controls = [];
	var form = panelWebInterface.formControls[formId];
	if(form && form.entries && form.entries.length>0 && form.entries[0].entries_subitem)
	{
		controls = panelWebInterface.formControls[formId].entries[0].entries_subitem;
		var index = controls.indexOf(controlData);
		if(index>=0)
		{
			if(up)
			{
				if(index>0)
				{
					controls.swapItems(index, index-1);
				}
			}
			else
			{
				if(index<controls.length)
				{
					controls.swapItems(index, index+1);
				}
			}
			panelWebInterface.formControls[formId].entries[0].entries_subitem = controls;
			panelWebInterface.bindFormDetails(formId, controlData);
		}
	}
}

panelWebInterface.generatePreview = function(formItems)
{
	var preview = $("table","#formPreview").empty();
	for(var j=0;j<formItems.length;j++)
	{
		var curFormItem = formItems[j];
		if(curFormItem)
		{
			var itemType = getTextValueFromXMLNode(curFormItem.item_type, "");
			var isRequired = "<span class='requiredField'>*</span>";
			var name = getTextValueFromXMLNode(curFormItem.name, "");
			if(getTextValueFromXMLNode(curFormItem.required, "") != "true")
			{
				isRequired = "";
			}
			var control = $("<tr id='"+name+"'><td class='previewLabel'>"+getTextValueFromXMLNode(curFormItem.label, "")+" " + isRequired + "</td><td class='previewContent'></td></tr>");
			preview.append(control);
			if(itemType == "label")
			{
				control.find("td.previewContent").append(getTextValueFromXMLNode(curFormItem.value, ""));
			}
			else if(itemType == "text")
			{
				var size = parseInt(getTextValueFromXMLNode(curFormItem.size, 0));
				if(isNumeric(size) && size >0)
				{
					size = "style='width:"+size+"px;'";
				}
				else
				{
					size = "";
				}
				control.find("td.previewContent").append("<input type='text' value='"+getTextValueFromXMLNode(curFormItem.value, "")+"' "+size+" />");
			}
			else if(itemType == "textarea")
			{
				var cols = parseInt(getTextValueFromXMLNode(curFormItem.cols, 0));
				if(isNumeric(cols) && cols >0)
				{
					cols = "cols="+cols;
				}
				else
				{
					cols = "";
				}

				var rows = parseInt(getTextValueFromXMLNode(curFormItem.rows, 0));
				if(isNumeric(rows) && rows >0)
				{
					rows = "rows="+rows;
				}
				else
				{
					rows = "";
				}
				control.find("td.previewContent").append("<textarea "+cols+" " + rows + ">"+getTextValueFromXMLNode(curFormItem.value, "")+"</textarea>");
			}
			else if(itemType == "radio" || itemType == "checkbox")
			{
				var options = curFormItem.options;
				options = options[0]["options_subitem"];
				for(var i=0;i<options.length;i++)
				{
					var curItem = options[i];
					if(curItem)
					{
						var opt = curItem.text.split(":");
						if(opt.length>1)
						{
							control.find("td.previewContent").append("&nbsp;<label><input name='"+name+"' value='"+opt[1]+"' type='"+itemType+"'>"+opt[0]+"</label>");
						}
						else
						{
							control.find("td.previewContent").append("&nbsp;<label><input name='"+name+"' type='"+itemType+"'>"+curItem.text+"</label>");
						}
					}
				}
			}
			else if(itemType == "combo")
			{
				var options = curFormItem.options;
				var name = getTextValueFromXMLNode(curFormItem.name, "");
				options = options[0]["options_subitem"];
				var selectList = "<select>";
				for(var i=0;i<options.length;i++)
				{
					var curItem = (options[i]);
					if(curItem)
					{
						var opt = curItem.text.split(":");
						if(opt.length>1)
						{
							selectList += "<option value='"+opt[1]+"'>"+opt[0]+"</option>";
						}
						else
						{
							selectList += "<option value='"+curItem.text+"'>"+curItem.text+"</option>";
						}
					}
				}
				selectList += "</select>";
				control.find("td.previewContent").append(selectList);
			}
		}
	}
	preview.form();
}

panelWebInterface.addControlToTheList = function(itemType, label, name, value, options, required, size, type, cols, rows, formId)
{
	$("table","#formPreview").empty();
	var formCustomFormList = $("#CustomForms", _panel);
	formId = formId || formCustomFormList.val();
	var controls = [];
	var form = panelWebInterface.formControls[formId];
	if(form && form.entries && form.entries.length>0 && form.entries[0].entries_subitem)
	{
		controls = panelWebInterface.formControls[formId].entries[0].entries_subitem;
		controls.push({
			item_type:[{text:itemType}],
			label:[{text:label}],
			name:[{text:name}],
			value:[{text:value}],
			options:options,
			required:[{text:required.toString()}],
			size:[{text:size}],
			type:[{text:type}],
			cols:[{text:cols}],
			rows:[{text:rows}]
		});
		panelWebInterface.formControls[formId].entries[0].entries_subitem = controls;
		panelWebInterface.bindFormDetails(formId);
	}
}

panelWebInterface.getFormControls = function(formId)
{
	var controls = [];
	var form = panelWebInterface.formControls[formId];
	if(form && form.entries && form.entries.length>0 && form.entries[0].entries_subitem)
	{
		controls = panelWebInterface.formControls[formId].entries[0].entries_subitem;
	}
	return controls;
}

panelWebInterface.bindFormDetails = function(formId, controlSelected)
{
	$("table","#formPreview").empty();
	var formCustomFormList = $("#CustomForms", _panel);
	formId = formId || formCustomFormList.val();
	var customFormControlsList = $("#custom_form_controls", _panel).empty();
	panelWebInterface.generatePreview([]);
	if(formId)
	{
		var formItems = panelWebInterface.getFormControls(formId);
		if(formItems)
		{
			for(var j=0;j<formItems.length;j++)
			{
				var curFormItem = formItems[j];
				if(curFormItem)
				{
					var itemType = getTextValueFromXMLNode(curFormItem.item_type, "");
					if(!itemType)
					{
						itemType = getTextValueFromXMLNode(curFormItem.type, "");
					}
					var label = getTextValueFromXMLNode(curFormItem.label, "");
					var name = getTextValueFromXMLNode(curFormItem.name, "");
					var control = itemType + ":" + label;
					var newControl = $("<li class='ui-widget-content' rel='"+name+"' control='"+control+"'>"+control+"</li>");
					customFormControlsList.append(newControl);
					newControl.data("controlData", curFormItem);
					if(controlSelected === curFormItem)
					{
						newControl.addClass("ui-widget-header").addClass("ui-selected");
					}
				}
			}
			panelWebInterface.generatePreview(formItems);
		}
	}
}

panelWebInterface.bindMiniURLDetails = function(item)
{
	var miniURLs = $("#miniURLs", _panel);
	item = item || miniURLs.find("li.ui-selected");
	if(!item || item.length==0)return;
	var data = item.data("controlData");
	if(data)
	{
		var detailsForm = _panel.find("#miniURLDetails");
		var inputs = detailsForm.find("input.ignoreBind").removeClass("ignoreBind");
		detailsForm.find("#miniURLHost").addClass("ignoreBind");
		bindValuesFromXML(detailsForm, data);
		detailsForm.find("#miniURLHost").removeClass("ignoreBind");
		inputs.removeClass("ignoreBind");
	}
}

panelWebInterface.saveContent = function()
{
	if(placeHolder.data("hasChanged"))
	{
		function saveMainPrefs(callback)
		{
			var xmlData =  '<server_prefs type="properties">'+buildXMLToSubmitForm(_panel)+'</server_prefs>';
			common.data.setXMLPrefs("server_settings/server_prefs/", "properties", "update", xmlData, function(data){
				data = $.xml2json(data, true);
				if(data.response_status && getTextValueFromXMLNode(data.response_status) && getTextValueFromXMLNode(data.response_status) == "OK")
				{
					if(callback)
					{
						callback(true);
					}
					else
					{
						growl("Data saved", "Your changes are saved", false, 5000);
					}
				}
				else
				{
					if(callback)
					{
						callback(false);
					}
					else
					{
						growl("Error while saving", "Your changes are not saved", true);
					}
				}
			});
		}

		function saveCustomForms(callback)
		{
			var xmlString = [];
			xmlString.push("<CustomForms type=\"vector\">");
			for(var formId in panelWebInterface.formControls)
			{
				var controls = [];
				var form = panelWebInterface.formControls[formId];
				var id = common.data.getTextContentFromPrefs(panelWebInterface.formControls[formId], "id");
				var name = common.data.getTextContentFromPrefs(panelWebInterface.formControls[formId], "name");
				xmlString.push("<CustomForms_subitem type=\"properties\">");
				xmlString.push("<entries type=\"vector\">");
				if(form && form.entries && form.entries.length>0 && form.entries[0].entries_subitem)
				{
					controls = panelWebInterface.formControls[formId].entries[0].entries_subitem;
					if(controls && id && name)
					{
						for(var item in controls)
						{
							var curItem = controls[item];
							if(curItem && curItem.item_type)
							{
								xmlString.push("<entries_subitem type=\"properties\">");
								for(var controlDetail in curItem)
								{
									if(controlDetail.toLowerCase() == "options")
									{
										var controlOpts = curItem[controlDetail];
										if(controlOpts && controlOpts.length)
										{
											xmlString.push("<options type=\"vector\">");
											for(var opt in controlOpts)
											{
												if(controlOpts[opt].options_subitem)
												{
													var subOpt = controlOpts[opt].options_subitem;
													for(var subItem in subOpt)
													{
														if(subOpt[subItem] && typeof subOpt[subItem].text != "undefined")
														{
															xmlString.push("<options_subitem>");
															var textVal = common.methods.htmlEncode(subOpt[subItem].text);
															if(textVal.length==0) textVal = ":";
															xmlString.push(textVal);
															xmlString.push("</options_subitem>");
														}
													}
												}
											}
											xmlString.push("</options>");
										}
									}
									else
									{
										xmlString.push("<"+controlDetail+">");
										if(curItem[controlDetail] && curItem[controlDetail].length>0)
										{
											xmlString.push(common.methods.htmlEncode(curItem[controlDetail][0].text));
										}
										else
										{
											xmlString.push("");
										}
										xmlString.push("</"+controlDetail+">");
									}
								}
								xmlString.push("</entries_subitem>");
							}
						}
					}
				}
				xmlString.push("</entries>");
				xmlString.push("<name>"+name+"</name>");
				xmlString.push("<id>"+id+"</id>");
				xmlString.push("</CustomForms_subitem>");
			}
			xmlString.push("</CustomForms>");
			var formSubItem = xmlString.join("");
			common.data.setXMLPrefs("server_settings/CustomForms/0"
				, "vector"
				, "reset"
				, formSubItem
				, function(data){
					data = $.xml2json(data, true);
					if(data.response_status && getTextValueFromXMLNode(data.response_status) && getTextValueFromXMLNode(data.response_status) == "OK")
					{
						if(callback)
						{
							callback(true);
						}
						else
						{
							growl("Data saved", "Your changes are saved", false, 5000);
						}
					}
					else
					{
						if(callback)
						{
							callback(true);
						}
						else
						{
							growl("Error while saving", "Your changes are not saved", true);
						}
					}
				}
			);
		}

		function saveMiniURLs(callback)
		{
			var xmlString = [];
			var formMiniURLsList = $("#miniURLs", _panel).find("li");
			if(formMiniURLsList.length>0)
			{
				xmlString.push("<miniURLs type=\"vector\">");
				formMiniURLsList.each(function(){
					xmlString.push("<miniURLs_subitem type=\"properties\">");
					var controlData = $(this).data("controlData");
					for(var item in controlData)
					{
						if(controlData[item].length)
						{
							if(controlData[item][0].text)
							{
								xmlString.push("<"+item+">"+common.methods.htmlEncode(controlData[item][0].text)+"</"+item+">");
							}
						}
					}
					xmlString.push("</miniURLs_subitem>");
				});
				xmlString.push("</miniURLs>");
			}
			var formSubItem = xmlString.join("");
			var action = xmlString.length>0 ? "reset" : "remove";
			common.data.setXMLPrefs("server_settings/miniURLs/0"
				, "vector"
				, action
				, formSubItem
				, function(data){
					data = $.xml2json(data, true);
					if(data.response_status && getTextValueFromXMLNode(data.response_status) && getTextValueFromXMLNode(data.response_status) == "OK")
					{
						if(callback)
						{
							callback(true);
						}
						else
						{
							growl("Data saved", "Your changes are saved", false, 5000);
						}
					}
					else
					{
						if(callback)
						{
							callback(true);
						}
						else
						{
							growl("Error while saving", "Your changes are not saved", true);
						}
					}
				}
			);
		}

		function saveLoginPages(callback)
		{
			var xmlString = [];
			var formloginPageList = $("#loginPageList", _panel).find("li");
			if(formloginPageList.length>0)
			{
				xmlString.push("<login_page_list type=\"vector\">");
				formloginPageList.each(function(){
					xmlString.push("<login_page_list_subitem type=\"properties\">");
					var controlData = $(this).data("controlData");
					for(var item in controlData)
					{
						if(controlData[item].length)
						{
							if(controlData[item][0].text)
							{
								xmlString.push("<"+item+">"+common.methods.htmlEncode(controlData[item][0].text)+"</"+item+">");
							}
						}
					}
					xmlString.push("</login_page_list_subitem>");
				});
				xmlString.push("</login_page_list>");
			}
			var loginPageSubItem = xmlString.join("");
			var action = xmlString.length>0 ? "reset" : "remove";
			common.data.setXMLPrefs("server_settings/login_page_list/0"
				, "vector"
				, action
				, loginPageSubItem
				, function(data){
					data = $.xml2json(data, true);
					if(data.response_status && getTextValueFromXMLNode(data.response_status) && getTextValueFromXMLNode(data.response_status) == "OK")
					{
						if(callback)
						{
							callback(true);
						}
						else
						{
							growl("Data saved", "Your changes are saved", false, 5000);
						}
					}
					else
					{
						if(callback)
						{
							callback(true);
						}
						else
						{
							growl("Error while saving", "Your changes are not saved", true);
						}
					}
				}
			);
		}

		function saveProxyRules(callback)
		{
			var xmlString = [];
			var proxyRulesList = $("#proxyRules", _panel).find("li");
			if(proxyRulesList.length>0)
			{
				xmlString.push("<proxyRules type=\"vector\">");
				proxyRulesList.each(function(){
					xmlString.push("<proxyRules_subitem type=\"properties\">");
					var controlData = $(this).data("controlData");
					for(var item in controlData)
					{
						if(controlData[item].length)
						{
							if(controlData[item][0].text)
							{
								xmlString.push("<"+item+">"+common.methods.htmlEncode(controlData[item][0].text)+"</"+item+">");
							}
						}
					}
					xmlString.push("</proxyRules_subitem>");
				});
				xmlString.push("</proxyRules>");
			}
			var loginPageSubItem = xmlString.join("");
			var action = xmlString.length>0 ? "reset" : "remove";
			common.data.setXMLPrefs("server_settings/proxyRules/0"
				, "vector"
				, action
				, loginPageSubItem
				, function(data){
					data = $.xml2json(data, true);
					if(data.response_status && getTextValueFromXMLNode(data.response_status) && getTextValueFromXMLNode(data.response_status) == "OK")
					{
						if(callback)
						{
							callback(true);
						}
						else
						{
							growl("Data saved", "Your changes are saved", false, 5000);
						}
					}
					else
					{
						if(callback)
						{
							callback(true);
						}
						else
						{
							growl("Error while saving", "Your changes are not saved", true);
						}
					}
				}
			);
		}

		common.UI.showIndicator(false, false, "Please wait..");
		saveMainPrefs(function(flag)
			{
				if(flag)
				{
					saveCustomForms(function(flag)
					{
						if(flag)
						{
							saveMiniURLs(function(flag)
							{
								saveLoginPages(function(flag)
								{
									saveProxyRules(function(flag){
										common.data.updateLocalPrefs(function(){
											common.UI.hideIndicator();
											if(flag)
											{
												growl("Data saved", "Your changes are saved", false, 5000);
												placeHolder.removeData("hasChanged");
											}
											else
											{
												growl("Error while saving", "Your changes are not saved", true);
											}
										});
									});
								});
							});
						}
					});
				}
		});
	}
	else
	{
		growl("No changes made", "", false, 3000);
	}
}