/*
Original code from  : http://www.tuttoaster.com/wp-content/uploads/demos/5/index.html
*/
$.widget("ui.form", {
    _init: function (stopProp) {
        var object = this;
        var form = this.element;
        var inputs = form.find("input , select ,textarea");
        form.find("fieldset").addClass("ui-widget-content");
        form.find("legend").each(function(){
			if(!$(this).parent().hasClass("noForm"))
			{
				if($(this).is(".normal"))
				{
					$(this).addClass("ui-priority-primary ui-corner-all");
				}
				else
				{
					$(this).addClass("ui-widget-header ui-corner-all");
				}
			}
		});
        form.addClass("ui-widget");
        $.each(inputs, function () {
			if($.browser && $.browser.msie && $.browser.version <= 8 && $(this).is(":radio"))
			{
				return;
			}
			if($(this).hasClass("form-created") || $(this).is("input[type='file']"))return;
            $(this).addClass('ui-state-default ui-corner-all form-created');
            $(this).wrap("<label />");
            if ($(this).is(":reset ,:submit")) object.buttons(this);
            else if ($(this).is(":checkbox")) object.checkboxes(this);
            else if ($(this).is("input[type='text']") || $(this).is("textarea") || $(this).is("input[type='password']") || $(this).is("select")) object.textelements(this);
            else if ($(this).is(":radio")) object.radio(this);
            else if ($(this).is("select")) object.selector(this);
            if ($(this).hasClass("date")) {
				if($(this).hasClass("time"))
				{
					$(this).datetimepicker({
						timeFormat: 'hh:mm TT',
						ampm: true
					});
				}
				else
				{
					$(this).datepicker();
				}
            }
			else if ($(this).hasClass("time")) {
				$(this).timepicker({
					timeFormat: 'hh:mm TT',
					ampm: true
				});
            }
			if($(this).hasClass("encryptPass"))
			{
				$(this).crushFtpEncryptPassword();
			}
        });
        $(".hover").hover(function () {
            $(this).addClass("ui-state-hover");
        }, function () {
            $(this).removeClass("ui-state-hover");
        });
    },
    textelements: function (element) {
		if($(element).is("textarea"))
		{
			$(element).addClass("nobg");
		}
        $(element).bind({
            focusin: function () {
                $(this).toggleClass('ui-state-focus');
            },
            focusout: function () {
                $(this).toggleClass('ui-state-focus');
            }
        });
    },
    buttons: function (element) {
        if ($(element).is(":submit")) {
            $(element).addClass("ui-priority-primary ui-corner-all ui-state-disabled hover");
            $(element).bind("click", function (event) {
                event.preventDefault();
				event.stopPropagation();
            });
        } else if ($(element).is(":reset")) $(element).addClass("ui-priority-secondary ui-corner-all hover");
        $(element).bind('mousedown mouseup', function () {
            $(this).toggleClass('ui-state-active');
        });
    },
    checkboxes: function (element) {
        $(element).parent("label").after("<span />");
        var parent = $(element).parent("label").next();
        $(element).addClass("ui-helper-hidden");
        parent.css({
            width: 16,
            height: 16,
            display: "block"
        });
        parent.wrap("<span class='ui-state-default ui-corner-all' style='display:inline-block;width:16px;height:16px;margin-right:5px;'/>");
        parent.parent().addClass('hover');
		if($(element).is(":checked"))
		{
			parent.toggleClass("ui-icon ui-icon-check");
		}
		if(!$(element).attr("disabled"))
		{
			parent.parent("span").click(function (event) {
				$(this).toggleClass("ui-state-active");
				parent.toggleClass("ui-icon ui-icon-check");
				if(!$(element).is(":checked"))
				{
					$(element).attr("checked","checked");
				}
				else
				{
					$(element).removeAttr("checked");
				}
				$(element).trigger("change");
				event.stopPropagation();
			});
			parent.parent("span").next("label[for]").click(function (event) {
				$(this).prev().toggleClass("ui-state-active");
				parent.toggleClass("ui-icon ui-icon-check");
				if(!$(element).is(":checked"))
				{
					$(element).attr("checked","checked");
				}
				else
				{
					$(element).removeAttr("checked");
				}
				event.preventDefault();
				$(element).trigger("change");
				event.stopPropagation();
			});
		}
    },
    radio: function (element) {
        $(element).parent("label").after("<span />");
        var parent = $(element).parent("label").next();
        $(element).addClass("ui-helper-hidden");        
        parent.wrap("<span class='ui-state-default ui-corner-all' style='display:inline-block;width:16px;height:16px;margin-right:5px;'/>");
        parent.parent().addClass('hover');
		if($(element).is(":checked"))
		{
			parent.toggleClass("ui-icon ui-icon-circle-check");
		}
		if(!$(element).attr("disabled"))
		{
			parent.parent("span").click(function (event) {
				$(element).closest(".customForm").find("input[name='"+$(element).attr("name")+"']").each(function(){
					var _parent = $(this).parent().next();
					$(_parent).removeClass("ui-state-active").removeClass("ui-icon ui-icon-circle-check").addClass("");
					$(_parent).find("span").removeClass("ui-state-active").removeClass("ui-icon ui-icon-circle-check").addClass("");
				});
				$(this).toggleClass("ui-state-active");
				parent.toggleClass("ui-icon ui-icon-circle-check");
				if(!$(element).is(":checked"))
				{
					$(element).attr("checked","checked");
				}
				event.stopPropagation();
				$(element).trigger("change");
			});
			parent.parent("span").next("label[for]").click(function (event) {
				$(element).closest(".customForm").find("input[name='"+$(element).attr("name")+"']").each(function(){
					var _parent = $(this).parent().next();
					$(_parent).removeClass("ui-state-active").removeClass("").removeClass("ui-icon ui-icon-circle-check").addClass("");
					$(_parent).find("span").removeClass("ui-state-active").removeClass("").removeClass("ui-icon ui-icon-circle-check").addClass("");
				});
				$(this).prev().toggleClass("ui-state-active");
				parent.toggleClass("ui-icon ui-icon-circle-check");
				if(!$(element).is(":checked"))
				{
					$(element).attr("checked","checked");
				}
				event.preventDefault();
				event.stopPropagation();
				$(element).trigger("change");
			});
		}
    },
    selector: function (element) {
        var parent = $(element).parent();
        parent.css({
            "display": "block",
            width: 140,
            height: 21
        }).addClass("ui-state-default ui-corner-all");
        $(element).addClass("ui-helper-hidden");
        parent.append("<span id='labeltext' style='float:left;'></span><span style='float:right;display:inline-block' class='ui-icon ui-icon-triangle-1-s' ></span>");
        parent.after("<ul class=' ui-helper-reset ui-widget-content ui-helper-hidden' style='position:absolute;z-index:50;width:140px;' ></ul>");
        $.each($(element).find("option"), function () {
            $(parent).next("ul").append("<li class='hover'>" + $(this).html() + "</li>");
        });
        $(parent).next("ul").find("li").click(function (event) {
            $("#labeltext").html($(this).html());
            $(element).val($(this).html());
			if(stopProp)
			{
				event.stopPropagation();
			}
        });
        $(parent).click(function (event) {
            $(this).next().slideToggle('fast');
            event.preventDefault();
			if(stopProp)
			{
				event.stopPropagation();
			}
        });
    }
});